module debounce(pb_debounced, pb, clock_100Hz);
input pb, clock_100Hz;
output pb_debounced;
reg [3:0] shift;
reg pb_debounced;

// filters out mechanical switch bounce for about 40ms,
// provided that the debounce clock is approximately 10ms (100Hz)
always @ (posedge clock_100Hz)
begin
	shift[2:0] <= shift[3:1];
	shift[3] <= pb;
	if (shift==4'b0000) pb_debounced <= 1'b0; 
	else pb_debounced <= 1'b1;
end 
endmodule
